Bug 8730 - Implement RPC-over-HTTP
Implement RPC-over-HTTP
Status: RESOLVED FIXED
Product: Samba 4.0
Classification: Unclassified
Component: DCE-RPCs and pipes
unspecified
All All
: P5 normal
: ---
Assigned To: Jelmer Vernooij
samba4-qa@samba.org
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-01-31 18:40 UTC by Milan Crha
Modified: 2015-07-31 21:30 UTC (History)
3 users (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Milan Crha 2012-01-31 18:40:33 UTC
It will be nice if ncacn_http is supported in samba4. I was told in [1] that Jelmer started work on this, but I found only branch [2], which doesn't contain much, and it 3 years old. I guess it should be easier to implement these days, especially for someone whom knows samba4's internals, when there is protocol description available [3]. I also believe there is and will be some demand for RPC-over-HTTP, aka Outlook Anywhere, these days (and in the future), thus it'll not be waste of time. OpenChange has such request as well [4], where's a link to samba-technical mail from Julien [5], which has patch for IDL.

I would help myself, but I realized I'm quite of idea here.

[1] https://bugzilla.gnome.org/show_bug.cgi?id=585638
[2] http://git.samba.org/?p=jelmer/samba4.git;a=shortlog;h=refs/heads/v4-0-ncacn-http
[3] http://msdn.microsoft.com/en-us/library/cc243950%28v=prot.10%29.aspx
[4] http://tracker.openchange.org/issues/42
[5] http://samba.2283325.n4.nabble.com/PATCH-Outlook-anywhere-ncacn-http-support-tt3073730.html
Comment 1 Milan Crha 2012-02-02 08:36:14 UTC
I realized yesterday that alpha17 has Julien's change (the [5]) included, thus there lefts "only" the rest in librpc.
Comment 2 Julien Kerihuel 2013-04-11 16:18:54 UTC
Hi Milan,

We are currently implementing ncacn_http client side in Samba DCERPC library at Zentyal and will make the code available to the Samba project when finished.

Upon merge complete, OpenChange applications (and to the extent gnome-evolution) will be able to use RoH without any further code changes.

Kind Regards,
Julien.
Comment 3 Milan Crha 2013-04-11 17:06:30 UTC
(In reply to comment #2)
> Upon merge complete, OpenChange applications (and to the extent
> gnome-evolution) will be able to use RoH without any further code changes.

Nice, that sounds interesting. The Outlook, at least my ancient 2007, has an explicit option to use RPC over HTTP, which might be confusing for users, at least those non-technical, but it's still an option. How will Samba recognize which connection type to use? I'm thinking of a case of an incorrect password. If you'll try both ways with the wrong password, then the server can lock the account sooner than after (say) 3 tries.
Comment 4 Julien Kerihuel 2013-04-24 10:33:07 UTC
> Nice, that sounds interesting. The Outlook, at least my ancient 2007, has an
> explicit option to use RPC over HTTP, which might be confusing for users, at
> least those non-technical, but it's still an option. How will Samba recognize
> which connection type to use? I'm thinking of a case of an incorrect password.
> If you'll try both ways with the wrong password, then the server can lock the
> account sooner than after (say) 3 tries.

The only change required for using ncacn_http instead of ncacn_ip_tcp is to change the binding string in OpenChange profile entry. Samba, based on the binding string will call the proper dcerpc library code and encapsulate the traffic over the proper transport layer. 

In OpenChange tools, we will enable this behavior by adding a --http switch to mapiprofile.
Comment 5 Stefan Metzmacher 2015-07-31 21:30:04 UTC
Fixed in 4.2